module join3(valid_out, valid_in0, valid_in1, valid_in2, stall_in, stall_out0, stall_out1, stall_out2);
	input stall_in;
	input valid_in0;
	input valid_in1;
	input valid_in2;
	output valid_out;
	output stall_out0;
	output stall_out1;
	output stall_out2;

	assign valid_out = valid_in0 & valid_in1 & valid_in2;
	assign stall_out0 = (stall_in | ~valid_out) & valid_in0;
	assign stall_out1 = (stall_in | ~valid_out) & valid_in1;
	assign stall_out2 = (stall_in | ~valid_out) & valid_in2;
endmodule
