import sys
import random

if __name__ == "__main__":
	try:
		c = int(sys.argv[1]) + 1
	except:
		print '''Usage: python makerndrom.py [highest number] > romfile.hex'''
		sys.exit(-1)
	random.seed()

	width = 32
	width_bytes = width / 8 
	depth = 256
	addrwidth = 8

	for i in range(0, depth):
		num = int(random.betavariate(2,2)*c)
		h = hex(num)[2:]
		if len(h) < width_bytes:
			h = ('0' * (width_bytes-len(h))) + h
		elif len(h) > width_bytes:
			h = h[0:width_bytes]
		print h + " // " + str(num)
