module function11(clk, reset, stall_int, valid_in, valid_out0, valid_out1, valid_out2, valid_out3, valid_out4, valid_out5, valid_out6, valid_out7, valid_out8, valid_out9, valid_out10, stall_out, stall_in0, stall_in1, stall_in2, stall_in3, stall_in4, stall_in5, stall_in6, stall_in7, stall_in8, stall_in9, stall_in10, condition0, condition1, condition2, condition3, condition4, condition5, condition6, condition7, condition8, condition9, condition10);
	input clk;
	input reset;
	input stall_int;
	input valid_in;
	input stall_in0;
	input stall_in1;
	input stall_in2;
	input stall_in3;
	input stall_in4;
	input stall_in5;
	input stall_in6;
	input stall_in7;
	input stall_in8;
	input stall_in9;
	input stall_in10;
	input condition0;
	input condition1;
	input condition2;
	input condition3;
	input condition4;
	input condition5;
	input condition6;
	input condition7;
	input condition8;
	input condition9;
	input condition10;
	output stall_out;
	output valid_out0;
	output valid_out1;
	output valid_out2;
	output valid_out3;
	output valid_out4;
	output valid_out5;
	output valid_out6;
	output valid_out7;
	output valid_out8;
	output valid_out9;
	output valid_out10;

	reg hold0;
	reg hold1;
	reg hold2;
	reg hold3;
	reg hold4;
	reg hold5;
	reg hold6;
	reg hold7;
	reg hold8;
	reg hold9;
	reg hold10;

	wire stall0_ = stall_in0 & hold0;
	wire stall1_ = stall_in1 & hold1;
	wire stall2_ = stall_in2 & hold2;
	wire stall3_ = stall_in3 & hold3;
	wire stall4_ = stall_in4 & hold4;
	wire stall5_ = stall_in5 & hold5;
	wire stall6_ = stall_in6 & hold6;
	wire stall7_ = stall_in7 & hold7;
	wire stall8_ = stall_in8 & hold8;
	wire stall9_ = stall_in9 & hold9;
	wire stall10_ = stall_in10 & hold10;
	assign stall_out = stall_int | (stall0_ & condition0) | (stall1_ & condition1) | (stall2_ & condition2) | (stall3_ & condition3) | (stall4_ & condition4) | (stall5_ & condition5) | (stall6_ & condition6) | (stall7_ & condition7) | (stall8_ & condition8) | (stall9_ & condition9) | (stall10_ & condition10);
	assign valid_out0 = condition0 & hold0 & valid_in;
	assign valid_out1 = condition1 & hold1 & valid_in;
	assign valid_out2 = condition2 & hold2 & valid_in;
	assign valid_out3 = condition3 & hold3 & valid_in;
	assign valid_out4 = condition4 & hold4 & valid_in;
	assign valid_out5 = condition5 & hold5 & valid_in;
	assign valid_out6 = condition6 & hold6 & valid_in;
	assign valid_out7 = condition7 & hold7 & valid_in;
	assign valid_out8 = condition8 & hold8 & valid_in;
	assign valid_out9 = condition9 & hold9 & valid_in;
	assign valid_out10 = condition10 & hold10 & valid_in;

	always @ (posedge clk) begin
		if (!reset) begin
			hold0 <= 0;
			hold1 <= 0;
			hold2 <= 0;
			hold3 <= 0;
			hold4 <= 0;
			hold5 <= 0;
			hold6 <= 0;
			hold7 <= 0;
			hold8 <= 0;
			hold9 <= 0;
			hold10 <= 0;
		end
		else begin
			hold0 <= ~(valid_in & stall_out) | stall0_ | ~condition0;
			hold1 <= ~(valid_in & stall_out) | stall1_ | ~condition1;
			hold2 <= ~(valid_in & stall_out) | stall2_ | ~condition2;
			hold3 <= ~(valid_in & stall_out) | stall3_ | ~condition3;
			hold4 <= ~(valid_in & stall_out) | stall4_ | ~condition4;
			hold5 <= ~(valid_in & stall_out) | stall5_ | ~condition5;
			hold6 <= ~(valid_in & stall_out) | stall6_ | ~condition6;
			hold7 <= ~(valid_in & stall_out) | stall7_ | ~condition7;
			hold8 <= ~(valid_in & stall_out) | stall8_ | ~condition8;
			hold9 <= ~(valid_in & stall_out) | stall9_ | ~condition9;
			hold10 <= ~(valid_in & stall_out) | stall10_ | ~condition10;
		end
	end
endmodule
