
module Logger(clk, address, data, en, we);

	parameter ADDRESS = 16'h0100;
	
	input clk;
	
	input en;
	input we;
	
	input [15:0] address;
	input [15:0] data;
	
	initial
		#10 $write("msp5000> ");
		
	always @ (posedge clk) begin
		if (en && we && address == ADDRESS) begin
//			if (data[15:8] != 8'd0)
	//			$write("%c", data[15:8]);
			$write("%c", data[7:0]);
		end
	end
endmodule