`timescale 1ns/100ps

/* File: tb.v
   
   Copyright (C) 2008
   Greg Hoover
   University of California, Santa Barbara */

   
module tb;
	reg clk;
	reg reset;
	
	proc sthread (.clk(clk),
				  .reset(reset),
				  .interrupt(1'b0),
				  .ivec(4'd0),
				  .iservice());
	
	initial begin 
		$dumpfile("wave.lxt"); 
		$dumpvars; 	
	end 
	
 	initial begin
    	clk = 1'b0;
     	 forever #5 clk = ~clk;
	end

	initial begin
		reset = 1'b0;
     	#10 reset = 1'b1;
	end
	
 	initial #5000000 $finish;
endmodule
